<?php

	/*
		Computerhilfe.de Gaestebuch
		(c) 2005 - Today by Computerhilfen.de Team
		---------------------------------------------------------------------
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public License
		along with this program; if not, see < http://www.gnu.org/licenses/ >
		---------------------------------------------------------------------
		Last Modification: (/myGB/myGB-lib/myGB-classes/main.class.php) October, 15th 2008
	*/


	/**
	* myGB Klasse fr Template
	*/

	class myGB_template // Definition
	{
	
		public $path;
		public $type;

		/**
		* Funktion myGB_template()
		* Initialisierung der Klasse myGB_template
		*
		* @uses: $smileypath, $titel, $gbversion, $captchatest, $templatepath --> Config-File Variables
		* @parameter: $path --> relativer Pfad zum Hauptverzeichnis, $admin --> Gibt aus, ob die Klasse von der Administration aus aufgerufen wird
		* @return: boolean/true
		*/
		function myGB_template($path, $admin)
		{
			$this->core_path			= $path; // relativer Pfad zum Hauptverzeichnis (/myGB/..)
			
			$this->core_admin			= $admin; // Aus der Administration aus aufgerufen?
			
			include($this->core_path.'myGB-config.inc.php'); // Config-Datei einbinden
			if(substr($smileypath, 0, 7) == 'http://')
			$this->config_smilies		= $smileypath; // Pfad zu den Smileys
			else
			$this->config_smilies		= $this->core_path.$smileypath; // Pfad zu den Smileys
			$this->config_title			= $titel; // Titel des Gstebuchs (Seitentitel mit <title>)
			$this->config_gbversion		= $gbversion; // Version des Gstebuchs
			$this->config_captcha		= $captchatest; // Captchatest aktiv?
			$this->config_template		= $templatepath; // Name des Templates
			$this->config_pages			= $seiten; // Anzahl der Eintrge pro Seite
			$this->config_textfile		= $this->core_path.$textfile; // Pfad zum Textfile (myGB.txt) mit Eintrgen

			if(isset($_REQUEST['action']))
			$this->request_action = $_REQUEST['action']; // "action" (Eintragen-Part anzeigen oder nicht)
			else
			$this->request_action = '';

			if(isset($_REQUEST['page']))
			$this->request_page = $_REQUEST['page']; // Aktuelle Seite des Gstebuchs
			else
			$this->request_page = 1;
			
			$this->config_template_gb		= 'guestbook.html'; // Template-File zum Anzeigen der Eintrge
			$this->config_template_all		= 'index.html'; // Template-File mit "allem"
			$this->config_template_insert	= 'insert.html'; // Template-File mit Eintragen-Part
			
			$this->template_whole_output = $this->myGB_load_template('all'); // Gesamtes Template laden
			$this->template_entry_output = $this->myGB_load_template('gb'); // Eintragsformatierung laden
			$this->template_enter_output = $this->myGB_load_template('insert'); // Eintragen-Part laden
			
			$this->num_of_entries = 0; // Anzahl aller Eintrge
			$this->num_of_pages = 0; // Anzahl der Seiten
			
			return true;
		}		
		
		/**
		* Funktion myGB_core_date()
		* Ausgabe eines formatierten Datums durch "{core::timestamp}"
		*
		* @uses: none
		* @parameter: $format --> bergeben bei core::timestamp=XXXXX
		* @return string/formatiertes Datum
		*/
		function myGB_core_date($format)
		{
			$format = trim($format);
			if(trim($format) == '') return date('Y', time()); // Falls keine Formatierung bergeben wurde, Y nehmen
			else
			{
				if(substr($format, 0, 1) == '=') $format = substr($format, 1); // '=' lschen
				return date($format, time()); // formatiertes Datum zurckgeben
			}
		}
		
		/**
		* Funktion myGB_load_template()
		* Laden der Templatedateien
		*
		* @uses: config_template, config_template_%
		* @parameter: $type --> Art des Templates (Gstebucheintrge, "Grundgerst", Eintragen-Part)
		* @return string/$template_file_output
		*/
		function myGB_load_template($type)
		{
			// Ausgabepuffer aktivieren
			ob_start();
			
			$varname = "config_template_" . $type; // "Typ" des Template-Files
			
			// Datei einbinden und Ausgabe in den Ausgabepuffer schreiben
			include($this->core_path.'myGB/myGB-templates/' . $this->config_template . '/' . $this->$varname);
			// Ausgabepuffer in Variable schreiben und Daten anschlieend weiterverarbeiten [andere Funktion]
			$template_file_output = ob_get_contents();
			// Ausgabepuffer beenden
			ob_clean();
			
			// Rckgabe der Variable zur Weiterverarbeitung
			return $template_file_output;
		}
		
		/**
		* Funktion myGB_prepare_template()
		* Vorbereiten des Templates fr Benutzung
		* Hier werden erste "Platzhalter" im Template ersetzt die gewissermaen "statisch" sind
		* Diese hngen von Daten der Config-Datei ab oder diese stehen schon jetzt fest
		*
		* @uses: config-Variables
		* @parameter: none
		* @return string/template_whole_output
		*/
		function myGB_prepare_template()
		{
			// Timestamp-Werte ersetzen
			$this->template_whole_output = preg_replace('#\{core::timestamp(.*?)\}#ise', '$this->myGB_core_date("$1")', $this->template_whole_output);
			// Titel (<title>) Wert einsetzen
			$this->template_whole_output = preg_replace('#\{config::title\}#is', $this->config_title, $this->template_whole_output);
			// $_SERVER['PHP_SELF'] einsetzen
			$this->template_whole_output = preg_replace('#\{show::php_self\}#si', basename($_SERVER['PHP_SELF']), $this->template_whole_output);
			// "Inhalt" einfgen, Eingabepanel oder Gstebucheintrage
			$this->template_whole_output = $this->myGB_insert_content($this->request_action);
			return $this->template_whole_output;
		}

		/**
		* Funktion myGB_insert_content()
		* Content einsetzen und Links ersetzen
		*
		* @uses: template_whole_output, num_of_entries, myGB_show_entries(), myGB_show_pager()
		* @parameter: $action --> bergabe von $_REQUEST['action'] (falls 'eintragen', Link ausblenden)
		* @return string/template_whole_output
		*/
		function myGB_insert_content($action)
		{
			// Falls User nicht beim Eintragen-Part ist, "Content" einsetzen
			if(trim($action) != 'eintragen')
			{
				// Ausgabe der Gstebucheintrge
				$this->template_whole_output = preg_replace('#\{show::entries\}#si', $this->myGB_show_entries(), $this->template_whole_output);
				// Link einsetzen zum Eintragen von Eintrgen
				$this->template_whole_output = preg_replace('#\{show::insertlink\}#si', '<a href="?action=eintragen">Ins Gstebuch eintragen</a><br><br>', $this->template_whole_output);
				// Ausgabe der Gesamtanzahl der Eintrge
				$this->template_whole_output = preg_replace('#\{show::count\}#si', '<br>Es sind <b>' . $this->num_of_entries . '</b> Eintr&auml;ge im G&auml;stebuch<br><br>', $this->template_whole_output);
				// Pager ausgeben
				$this->template_whole_output = preg_replace('#\{show::pages\}#si', $this->myGB_show_pager(), $this->template_whole_output);				
			}
			else // Eintragen-Part
			{
				// Link zum Eintragen-Part entfernen
				$this->template_whole_output = preg_replace('#\{show::insertlink\}#si', '', $this->template_whole_output);
				// Pager entfernen
				$this->template_whole_output = preg_replace('#\{show::pages\}#si', '', $this->template_whole_output);
				// Anzahl der Beitrge entfernen
				$this->template_whole_output = preg_replace('#\{show::count\}#si', '', $this->template_whole_output);
				// Eingabe-Panel einfgen
				$this->template_whole_output = $this->myGB_insert_panel();
			}
			// "Fertige" Seite zurckgeben mit Content
			return $this->template_whole_output;
		}
		
		/**
		* Funktion myGB_insert_panel()
		* Einsetzen des Eintragen-Teils fr das Gstebuch
		*
		* @uses: none
		* @parameter: none
		* @return string/template_whole_output
		*/
		function myGB_insert_panel()
		{
			// Rechenaufgabe und Lsung fr Rechenaufgabe ausrechnen
			$zahl1 = rand(10,21); // Erste Zahl (zwischen 10 und 21)
			$zahl2 = rand(1,9); // Zweite Zahl (zwischen 1 und 9)
			$vorzeichen = rand(1,2); // Vorzeichen whlen
			if($vorzeichen == 1) // Addition
			{
				$loesung = $zahl1 + $zahl2; // Lsung berechnen
				$string = 'vpx'.($zahl1+10).'x'.($zahl2+10); // String generieren fr Captcha-Grafik
			}
			else
			{
				$loesung = $zahl1 - $zahl2;
				$string = 'vmx'.($zahl1+10).'x'.($zahl2+10);
			}
			
			// "Content" einfgen = Eingabe-Panel
			$this->template_whole_output = preg_replace('#\{show::entries\}#si', $this->template_enter_output, $this->template_whole_output);
			// PHP_SELF einfgen: Link zum Gstebuch
			$this->template_whole_output = preg_replace('#\{show::php_self\}#si', basename($_SERVER['PHP_SELF']), $this->template_whole_output);
			// String einfgen zum Einfgen des Captcha-Links
			$this->template_whole_output = preg_replace('#\{show::captchalink\}#si', $string, $this->template_whole_output);
			// Lsung einfgen fr Javascript-Funktion (berprfen der Usereingabe)
			$this->template_whole_output = preg_replace('#\{show::captcha_loesung\}#si', $loesung, $this->template_whole_output);
			// Seite zurckgeben mit eingefgtem Eingabe-Panel
			return $this->template_whole_output;
		}
		
		/**
		* Funktion myGB_show_entries()
		* Auslesen und Ausgabe der Eintrge im Gstebuch
		*
		* @uses: none
		* @parameter: none
		* @return string/template_whole_output
		*/
		function myGB_show_entries()
		{
			// Smiley-Pfade ersetzen
			$this->template_entry_output = preg_replace('#\{config::smileypath\}#si', $this->config_smilies, $this->template_entry_output);
			
			$all_gb_entries = ''; // In dieser Variable werden alle Eintrge zwischengespeichert
		
			/*
			Hier das Gstebuch ffnen und alle Eintrge in ein Array einlesen;
			Fehlermeldung bei noch nicht vorhandener Datei wird unterdrckt
			und die Datei automatisch angelegt
			*/
			$eintraege = @file($this->config_textfile);
			/*
			Anzeigen der Eintrge

			Solange Eintrge vorhanden sind, wird eine Schleife durchlaufen
			von hinten nach vorne (also neueste zuerst)

			Hier wird gleichzeitig die Logik fr die dynamische Generierung
			der Seitenlinks erzeugt
			*/
			if(!$eintraege) // Textdatei berhaupt vorhanden?
			{
				$max = 0;
				$this->num_of_entries = 0;
			}
			else
			{
				// Start-Position berechnen
				$start = (count($eintraege) - 1) - $this->config_pages * ($this->request_page - 1);
				// End-Position berechnen
				$stop = (count($eintraege) - 1) - $this->config_pages * ($this->request_page - 1) - $this->config_pages + 1;
				
				// berprfen ob Start- und Endposition gltig sind
				if ($start > (count($eintraege) - 1)) $start = count($eintraege) - 1;
				if ($stop < 0) $stop = 0;

				// Maximale Anzahl an Beitrgen
				$max = count($eintraege);
				$this->num_of_entries = $max;
				
				for ($a = $start; $a >= $stop; $a--)
				{
					// Die einzelnen Teile des Eintrags extrahieren
					$Eintrag = explode('|', $eintraege[$a]);
					// Ausgabe der Eintrge
					$all_gb_entries .= $this->myGB_format_entry($Eintrag, $a);
				}
			}
			// "Fertige" Eintrge ausgeben
			return $all_gb_entries;
		}
		
		/**
		* Funktion myGB_show_date()
		* Ausgabe des formatierten Datums "{show::gb_date=XXXXXX}"
		*
		* @uses: none
		* @parameter: $dateformat --> bergeben bei show::gb_date=XXXXXX, $date --> Datum Gstebucheintrags (Timestamp oder schon formatiert)
		* @return string/formatiertes Datum
		*/
		function myGB_show_date($dateformat, $date)
		{
			$dateformat = trim($dateformat);
			if(trim($dateformat) == '')
			{
				if(preg_match_all('#([\d]+?)\.([\d]+?)\.([\d]+?)$#si', $date, $matches, PREG_SET_ORDER))
				{
					$time = mktime(12, 0, 0, $matches[0][2], $matches[0][1], $matches[0][3]);
					return date('d.m.y', $time);
				}
				else return date('d.m.y', $date);
			}
			else
			{
				if(substr($dateformat, 0, 1) == '=') $dateformat = substr($dateformat, 1);
				
				if(preg_match_all('#([\d]+?)\.([\d]+?)\.([\d]+?)$#si', $date, $matches, PREG_SET_ORDER))
				{
					$time = mktime(12, 0, 0, $matches[0][2], $matches[0][1], $matches[0][3]);
					return date($dateformat, $time);
				}
				else return date($dateformat, $date);
			}
		}
		
		/**
		* Funktion myGB_entry_email()
		* Ausgabe eines formatierten EMail-Links durch "{show::gb_mail=XXXXXX}"
		*
		* @uses: none
		* @parameter: $mailtext --> bergeben bei show::gb_mail=XXXXXX, $link --> Email des Gstebucheintrags
		* @return string/formatierter EMail-Link
		*/
		function myGB_entry_email($mailtext, $link)
		{
			$mailtext = trim($mailtext);
			if(trim($mailtext) == '') return '';
			else
			{
				if(trim($link) == '' OR !preg_match('#[a-z0-9_-]+(\.[a-z0-9_-]+)*@([0-9a-z][0-9a-z-]*[0-9a-z]\.)+([a-z]{2,4}|museum)#si', $link)) return '';
				if(substr($mailtext, 0, 1) == '=') $mailtext = substr($mailtext, 1);	
				return str_replace('%', $link, $mailtext);
			}
		}
		
		/**
		* Funktion myGB_entry_link()
		* Ausgabe eines formatierten Homepagelinks durch "{show::gb_hpage=XXXXXX}"
		*
		* @uses: none
		* @parameter: $linktext --> bergeben bei show::gb_hpage=XXXXXX, $link --> Link des Gstebucheintrags
		* @return string/formatierter Homepagelink
		*/
		function myGB_entry_link($linktext, $link)
		{
			$linktext = trim($linktext);
			if(trim($linktext) == '') return '';
			else
			{	
				
				if(substr($linktext, 0, 1) == '=') $linktext = substr($linktext, 1);
				if(trim($link) == 'http://' OR trim($link) == 'http:///' OR trim($link) == '') return '';
				else
				{
					$prelink = substr($link, 0, 4);
					if($prelink == 'www.') $link = 'http://'.$link;
					return str_replace('%', $link, $linktext);
				}
			}
		}
		
		/**
		* Funktion myGB_format_entry()
		* Formatierung der Ausgabe, Einfgen der Daten ins Template
		*
		* @uses: none
		* @parameter: $Eintrag --> Daten des Eintrags, $id --> ID des Eintrags (u.a. fr den "Lschenlink" in der Administration)
		* @return string/Einzelner Gstebucheintrag
		*/		
		function myGB_format_entry($Eintrag, $id)
		{
			// Gstebuch-Template
			$this_gb_entry =  $this->template_entry_output;
			// Falls das Gstebuch nicht von der Administration aus aufgerufen wird, Platzhalter fr die Administration ersetzen
			if($this->core_admin == false)
			{
				$this_gb_entry = preg_replace('#\{admin::dellink\}#is', '', $this_gb_entry);
				$this_gb_entry = preg_replace('#\{admin::commentpanel\}#is', '', $this_gb_entry);
			}
			else
			{
				$this_gb_entry = preg_replace('#\{admin::dellink\}#is', '<td rowspan="4" class="inhalt" style="padding: 5px"><a onclick="return confirm(\'Wirklich loeschen?\');" href="frame.php?PHPSESSID='.session_id().'&del=true&eintrag='.$id.'"><img src="'.$this->config_smilies.'/form/del.gif"></a></td></tr><tr>', $this_gb_entry);
				$this_gb_entry = preg_replace('#\{admin::commentpanel\}#is', '<tr><td class="inhalt" colspan="4">Kommentar: <form action="frame.php?PHPSESSID='.session_id().'" method="POST"><input type="text" name="komment"><input type="submit" name="submit" value="Kommentieren"><input type="hidden" name="eintrag" value="'.$id.'"></form></td></tr>', $this_gb_entry);
			}	
			// Name des Gstebucheintrags eintragen
			$this_gb_entry = preg_replace('#\{show::gb_name\}#si', $Eintrag[0], $this_gb_entry);
			// Datum einfgen
			$this_gb_entry = preg_replace('#\{show::gb_date(.*?)\}#mise', '$this->myGB_show_date("$1", "'.$Eintrag[3].'")', $this_gb_entry);
			// Email und Homepage eintragen
			$this_gb_entry = preg_replace('#\{show::gb_mail(.*?)\}#mise', '$this->myGB_entry_email("$1", "'.$Eintrag[2].'")', $this_gb_entry);
			$this_gb_entry = preg_replace('#\{show::gb_hpage(.*?)\}#mise', '$this->myGB_entry_link("$1", "'.$Eintrag[1].'")', $this_gb_entry);
			// Eintrag mit BB-Code formatieren und ebenfalls einfgen
			$this_gb_entry = preg_replace('#\{show::gb_entry\}#si', myGB_bbcodesmilie(stripslashes(nl2br($Eintrag[4]))), $this_gb_entry);
			// <br /> ersetzen durch <br> (kein XHTML!)			
			$this_gb_entry = preg_replace('#\<br(.*?)/>#si', '<br>', $this_gb_entry);
			return $this_gb_entry; // Fertigen Eintrag zurckgeben
		}
		
		/**
		* Funktion myGB_show_pager()
		* Ausgabe des Pagers zum Navigieren durch das Gstebuch
		*
		* @uses: none
		* @parameter: none
		* @return string/formatierter Pager
		*/		
		function myGB_show_pager()
		{
			$pager = 'Seiten: '; // Zwischenspeicher in den der Pager reinkommt
			// Anzahl der Seiten
			if( !isset($this->num_of_entries) or trim($this->num_of_entries) == '' ) $this->num_of_pages = 0;
			// Falls keine Beitrge vorhanden sind, Anzahl der Seiten auf 1 setzen
			if ($this->num_of_entries == 0) $this->num_of_pages = 1;
			// Ansonsten Anzahl der Seiten ausrechnen
			else $this->num_of_pages = intval(($this->num_of_entries - 1) / $this->config_pages) + 1;

			// Links zu den einzelnen Seiten ausgeben
			for ($i = 1; $i <= $this->num_of_pages; $i++)
			{
				if ($i == $this->request_page) $pager .= ' <b>['.$i.']</b> ';
				else $pager .= ' <a href="'.$_SERVER['PHP_SELF'].'?page='.$i.'">'.$i.'</a> ';
			}

			return $pager; // Pager zurckgeben
		}
		
		
	}
	
?>